# std::tr1::variate_generator< _Engine, _Dist > Class Template Reference
[Random Number Generation]

List of all members.

## Detailed Description

### template<typename _Engine, typename _Dist>
class std::tr1::variate_generator< _Engine, _Dist >

Produces random numbers on a given disribution function using a un uniform random number generation engine.

Todo:
  the engine_value_type needs to be studied more carefully.

Definition at line 169 of file random.

## Public Types

- typedef __gnu_cxx::__enable_if<
  is_arithmetic< result_type
  >::value, result_type >::__type _IsValidType
- typedef _Dist distribution_type
- typedef _Engine engine_type
- typedef __detail::_Adaptor<
  _Engine, _Dist > engine_value_type
- typedef _Dist::result_type result_type

## Public Member Functions

- const distribution_type & distribution () const
- distribution_type & distribution ()
- const engine_value_type & engine () const
- engine_value_type & engine ()
- result_type max () const
- result_type min () const
- template<typename _Tp> result_type operator() (_Tp __value)
- result_type operator() ()
- variate_generator (engine_type __eng, distribution_type __dist)

## Constructor & Destructor Documentation

template<typename _Engine, typename _Dist>

std::tr1::variate_generator< _Engine, _Dist >::variate_generator | ( | engine_type | __eng,
|  | distribution_type | __dist |
| ) |  |  | `[inline]`

Constructs a variate generator with the uniform random number generator `__eng` for the random distribution `__dist`.

Exceptions:

  | Any | exceptions which may thrown by the copy constructors of the `_Engine` or `_Dist` objects.

Definition at line 193 of file random.

## Member Function Documentation

template<typename _Engine, typename _Dist>

const distribution_type& std::tr1::variate_generator< _Engine, _Dist >::distribution | ( |  | ) | const`[inline]`

Gets a const reference to the underlying random distribution.

Definition at line 238 of file random.

template<typename _Engine, typename _Dist>

distribution_type& std::tr1::variate_generator< _Engine, _Dist >::distribution | ( |  | ) | `[inline]`

Gets a reference to the underlying random distribution.

Definition at line 231 of file random.

template<typename _Engine, typename _Dist>

const engine_value_type& std::tr1::variate_generator< _Engine, _Dist >::engine | ( |  | ) | const`[inline]`

Gets a const reference to the underlying uniform random number generator object.

Definition at line 224 of file random.

template<typename _Engine, typename _Dist>

engine_value_type& std::tr1::variate_generator< _Engine, _Dist >::engine | ( |  | ) | `[inline]`

Gets a reference to the underlying uniform random number generator object.

Definition at line 216 of file random.

template<typename _Engine, typename _Dist>

result_type std::tr1::variate_generator< _Engine, _Dist >::max | ( |  | ) | const`[inline]`

Gets the closed upper bound of the distribution interval.

Definition at line 252 of file random.

template<typename _Engine, typename _Dist>

result_type std::tr1::variate_generator< _Engine, _Dist >::min | ( |  | ) | const`[inline]`

Gets the closed lower bound of the distribution interval.

Definition at line 245 of file random.

template<typename _Engine, typename _Dist>
template<typename _Tp>

result_type std::tr1::variate_generator< _Engine, _Dist >::operator() | ( | _Tp | __value | ) | `[inline]`

WTF?

Definition at line 208 of file random.

template<typename _Engine, typename _Dist>

result_type std::tr1::variate_generator< _Engine, _Dist >::operator() | ( |  | ) | `[inline]`

Gets the next generated value on the distribution.

Definition at line 200 of file random.

The documentation for this class was generated from the following file:

- random